% Calculate LQR gain and estiamtor gain
% unfinished code used to implement LQG on MIMO plant

% Author: Sindre Johan Heggheim, sindrjh@stud.ntnu.no, December 18th, 2017
% Specialization project TKP4580 at Department of Chemical Engineering
clear 
clc
load('WS_MIMO_models.mat')
run('init')
nu = 3;
ny = 2;
nx = 4;

% run('steadyState')
stst.y = [31.51,26.50]';
stst.u = [0.5,0.2,0.5]';

% state space model:
ssmodel = ss(MIMO_tf);
[A,B,C,D] = ssdata(ssmodel);

% Kalman filter gain:
G = zeros(nx,1);
H = zeros(ny,1); 
SSmodel = ss(A,[B G],C,[D H],Ts,'inputname',{'u1' 'u2' 'u3' 'w'},...
    'outputname',{'y1' 'y2'});
Qn = 0;
Rn = [1,0;0,1];
[K_f,L,P] = kalman(SSmodel,Qn,Rn);

% LQR gain:
Q = diag([0,1,0,0]);
R = diag([1,1e9,1e9]);
[K_lqr,S,e] = lqr(A,B,Q,R);
x0 = L*stst.y;
u0 = stst.u;