% initialization of MIMO system.
% Init TOM1A 
com = 'COM4';   % com port
delete(instrfind({'Port'},{com}));
baud = 250000;  % baud rate 
Ts  = 0.1;      % Sampling time period
fTt = 0.05;     % Filter time constant for temperature (0.05s - 10s)
fTl = 0.05;     % Filter time constant for light intensity (0.05s - 10s)
fTf = 0.1;      % Filter time constant for light intensity (0.1s - 10s)
t_sim = 800;    % Simulation time
y0 = 0;         % Shifting of temperature 

% Fixed inputs 
fixed_u1 = 0;   
fixed_u2 = 0;
fixed_u3 = 0;

% Tresholds alternative controllers:
altu1_threshold = 0;
altu2_threshold = 0;

% Disturbances
stepTime_d1 = 0;
step_d1= 0;
stepTime_d2 = 0;
step_d2 = 0;
stepTime_d3 = 0;
step_d3 = 0;
stepTime_d4 = 0;
step_d4 = 0;

% Temperature setpoints:
y1_s0 = 0;
stepTime_ys1_1 = 0;
step_ys1_1 = +0;
stepTime_ys1_2 = 0;
step_ys1_2 = -0;

% Light Intensity setpoints:
y2_s0 = 0;
stepTime_ys2_1 = 0;
step_ys2_1 = 0;
stepTime_ys2_2 =  0;
step_ys2_2 = 0;